//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef G_MUSICBOX
#define G_MUSICBOX

#include "SDL_Mixer.h"
#include "sn_global.h"
#include <string>

using namespace std;

#ifndef G_SOUND_DEFINES
	#define G_SOUND_DEFINES
	#if defined(__APPLE__)
		#define G_DEFAULT_SOUND_RATE 22050
		#define G_DEFAULT_SOUND_CHANNELS 2
		#define G_DEFAULT_SOUND_BUFFERS 128
	#else
		#define G_DEFAULT_SOUND_RATE 22050
		#define G_DEFAULT_SOUND_CHANNELS 2
		#define G_DEFAULT_SOUND_BUFFERS 1024
	#endif
#endif

#define G_PLAYLISTMAX 8

class g_MusicBox
{
public:
	g_MusicBox();
	~g_MusicBox();

	void load(string musicFilepath);
	void load(string filepath, int playlistNumber);
	void play();
	void play(int playlistNumber);
	void playOnce();
	void playOnce(int playlistNumber);
	void pause();
	void unpause();
	void pauseToggle();
	void stop();
	void fadeOut();
	void fadeOut(int milliseconds);
	void free();
	void free(int playlistNumber);
	
	int isPlaying();
	int isFadingOut();
	
	void mute();
	void unmute();
	int isMuted();
	
private:
	Mix_Music * music[G_PLAYLISTMAX];
	//char filepath[255];
	int playing; //-1 means not playing, 1-5 means that playlist number is playing
	int muted;
};

#endif