//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef G_NOISEMAKER
#define G_NOISEMAKER

#include "SDL_Mixer.h"
#include "sn_global.h"

#ifndef G_SOUND_DEFINES
#define G_SOUND_DEFINES
	#if defined(__APPLE__)
		#define G_DEFAULT_SOUND_RATE 22050
		#define G_DEFAULT_SOUND_CHANNELS 2
		#define G_DEFAULT_SOUND_BUFFERS 128
	#else
		#define G_DEFAULT_SOUND_RATE 22050
		#define G_DEFAULT_SOUND_CHANNELS 2
		#define G_DEFAULT_SOUND_BUFFERS 1024
	#endif
#endif

#define G_NOISEINDEXMAX 20
#define G_NOISECHANNELSDEFAULT 16

class g_Noisemaker 
{
public:
	g_Noisemaker();
	g_Noisemaker(int noiseChannels);
	~g_Noisemaker();
	
	void load(char * filename, int noiseIndex);
	void play(int noiseIndex);
	void free(int noiseIndex);
	
	void mute();
	void unmute();
	int isMuted();
	
private:
	Mix_Chunk * chunk[G_NOISEINDEXMAX];
	int allocatedNoiseChannels;
	int muted;
};

#endif