#ifndef SN_3DMODEL
#define SN_3DMODEL

#include <vector>
#include "sn_TextureCollection.h"
#include "sn_Collider.h"

using namespace std;

struct sn_quadFace
{
	float x1, y1, z1,
	      x2, y2, z2,
	      x3, y3, z3,
		  x4, y4, z4;
	GLuint textureID;
	unsigned char alpha;
	bool isQuad;
	bool hFlip;
	bool vFlip;
	bool repeating;
};

class sn_3Dmodel
{
public:
	sn_3Dmodel();
	~sn_3Dmodel();
	void init(sn_TextureCollection * PTC, const string &filename);
	void draw(int facingDir) const;
	void drawAlpha(int facingDir) const;
	sn_Collider getCollider();
private:
	vector<sn_quadFace> faces;
	vector<sn_quadFace> alphaFaces;
	sn_TextureCollection * pTextures;
	sn_Collider collider;	
	
	GLuint drawDL;
	GLuint drawAlphaDL;
	
	void createDrawDL(float xl, float yl, float zl);
	void createDrawAlphaDL(float zl, float yl, float zl);
};


#endif