#include "sn_3DmodelCollection.h"
#include <iostream>
using namespace std;

sn_3DmodelCollection::sn_3DmodelCollection()
{
	pTextures = NULL;
}

sn_3DmodelCollection::sn_3DmodelCollection(sn_TextureCollection * pTC)
{
	init(pTC);
}

void sn_3DmodelCollection::init(sn_TextureCollection * pTC)
{
	pTextures = pTC;
}

int sn_3DmodelCollection::load(const string &filename)
{
	if (modelIndex.find(filename) != modelIndex.end())
	{
		//there is already a model with this filename loaded so return without loading
		return false;
	}
	else
	{
		//cerr << "loading model: " << filename << endl;
		sn_3Dmodel newModel;
		models.push_back(newModel);
		models.back().init( pTextures, filename ); //must init before using (does loading, display lists, etc.)
		modelIndex[filename] = models.size()-1;
		return true;
	}
}

int sn_3DmodelCollection::getModelIndex(const string &filename)
{
	if (modelIndex.find(filename) == modelIndex.end())
	{
		return -1;
	}
	else
	{
		return modelIndex[filename];
	}
}

void sn_3DmodelCollection::draw(int modelIndex, int facingDir) const
{
	models[modelIndex].draw(facingDir);
}

void sn_3DmodelCollection::drawAlpha(int modelIndex, int facingDir) const
{
	models[modelIndex].drawAlpha(facingDir);
}

sn_Collider sn_3DmodelCollection::getCollider(int modelIndex)
{
    sn_Collider c = models[modelIndex].getCollider();
	return c;
}

void sn_3DmodelCollection::reset()
{
	models.clear();
	modelIndex.clear();
}