#ifndef SN_3DMODELCOLLECTION
#define SN_3DMODELCOLLECTION

#include <map>
#include <vector>
#include <string>
#include "sn_3Dmodel.h"
#include "sn_TextureCollection.h"
using namespace std;

class sn_3DmodelCollection
{
public:
	sn_3DmodelCollection();
	sn_3DmodelCollection(sn_TextureCollection * pTC);
	void init(sn_TextureCollection * pTC);
	
	int load(const string &filename);
	int getModelIndex(const string &filename);
	void draw(int modelIndex, int facingDir) const;
	void drawAlpha(int modelIndex, int facingDir) const;
	sn_Collider getCollider(int modelIndex);
	
	void reset();
private:
	map<string,int> modelIndex;
	vector<sn_3Dmodel> models;
	sn_TextureCollection * pTextures;
};

#endif
