#ifndef SN_ANIMATIONSEQLIST
#define SN_ANIMATIONSEQLIST

#include "SDL_OpenGL.h"
#include "sn_global.h"
#include "sn_TextureCollection.h"
#include "sn_TextureSegmentList.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <string>
using namespace std;

struct sn_animationFrame
{
	int texNumber;
	int texSeg;
	unsigned int duration;
};

struct sn_sequenceInfo
{
	int indexOfStart;
	int length;
};

class sn_AnimationSeqList
{
public:
	void init( sn_TextureCollection * pTextureCollection );
	int load( string filename );
	void draw( string sequenceName, int frameNumber );
	void draw( string sequenceName, int frameNumber,  float scale, bool horizFlip, bool vertFlip );
	unsigned int getDuration( string sequenceName, int frameNumber );
	int getLength( string sequenceName );
	
private:
	vector<sn_TextureSegmentList> texSegList;
	sn_TextureCollection * pTexCollection;
	vector<sn_animationFrame> allFrames;
	map<string,sn_sequenceInfo> sequences;
};

#endif
