#ifndef SN_BUTTON
#define SN_BUTTON

#include "sn_global.h"
#include "string.h"

#if defined(_WIN32)
	#include "stdlib.h"
	#include "windows.h"
#endif

#include <string>
using namespace std;
#include "sn_FontTyper.h"

enum sn_ButtonType
{   
	kSBBT_boxed = 0,
	kSBBT_checkbox,
	kSBBT_smallAndBlue,
	kSBBT_tinyAndBlue,
	kSBBT_label,
	kSBBT_upArrow,
	kSBBT_downArrow,
	kSBBT_CW,
	kSBBT_CC
};

class sn_Button
{
public:
	sn_Button();
	void init(sn_FontTyper * fontToUse, float xPosition, float yPosition, 
			  sn_ButtonType buttonType, const char * name, ... );
	void setLabel( string &newLabel );
	void setLabel( const char * name, ... );
	void moveBy( float xChange, float yChange);
	void moveTo( float newX, float newY );
	int isOn();
	int click( float clickX, float clickY );
	int rollover( float clickX, float clickY );
	void turnOff();
	void turnOn();
	
	void draw();
	void animate(Uint16 ticksPassed);
	
	float getX();
	float getY();
	float getWidth();
	float getHeight();
	
private:
	sn_FontTyper * pTyper;
	float x, y, width, height;
	int on;
	bool over;
	sn_ButtonType type;
	string label;
};

#endif
