#include "sn_Collider.h"

void sn_Collider::init( float xCenter, float yCenter, float zCenter, float xLength, float yLength, float zLength )
{
	x = xCenter - xLength*0.5;
	y = yCenter - yLength*0.5;
	z = zCenter - zLength*0.5;
	
	xl = xLength;
	yl = yLength;
	zl = zLength;
}

void sn_Collider::initAbs( float xa, float ya, float za, float xLength, float yLength, float zLength )
{
	x = xa;
	y = ya;
	z = za;
	
	xl = xLength;
	yl = yLength;
	zl = zLength;
}

void sn_Collider::moveTo( float xCenter, float yCenter, float zCenter )
{
	x = xCenter - xl*0.5;
	y = yCenter - yl*0.5;
	z = zCenter - zl*0.5;
}

void sn_Collider::moveBy( float xOffset, float yOffset, float zOffset )
{
	x += xOffset;
	y += yOffset;
	z += zOffset;
}

bool sn_Collider::collisionWith( sn_Collider c)
{
	if (c.z+c.zl < z) return false;
	if (c.z > z+zl) return false;
	if (c.x+c.xl < x) return false;
	if (c.x > x+xl) return false;
	if (c.y+c.yl < y) return false;
	if (c.y > y+yl) return false;
	/*
	if ( ((c.z >= z && c.z <= z+zl) || ( c.z+c.zl >= z && c.z+c.zl <= z+zl)) &&
		 ((c.y >= y && c.y <= y+yl) || ( c.y+c.yl >= y && c.y+c.yl <= y+yl)) &&
		 ((c.x >= x && c.x <= x+xl) || ( c.x+c.xl >= x && c.x+c.xl <= x+xl)) )
	{
		return false;
	}
	if ( ((z >= c.z && z <= c.z+c.zl) || ( z+zl > c.z && z+zl <= c.z+c.zl)) &&
		 ((y >= c.y && y <= c.y+c.yl) || ( y+yl >= c.y && y+yl <= c.y+c.yl)) &&
		 ((x >= c.x && x <= c.x+c.xl) || ( x+xl >= c.x && x+xl <= c.x+c.xl)) )
	{
		return false;
	}
	*/
	return true;
}

bool sn_Collider::collisionWithBounds( float xmin, float xmax, float ymin, float ymax, float zmin, float zmax )
{
	if (x+xl > xmax || x < xmin ||
		y+yl > ymax || y < ymin ||
		z+zl > zmax || z < zmin )
	{
		return true;
	}
	return false;
}

void sn_Collider::textOut()
{
	cout << "x: " << x << ", y: " << y << ", z: " << z << ", xl: " << 
		xl << ", yl: " << yl << ", zl: " << zl << endl;
}

void sn_Collider::draw()
{
	glDisable(GL_TEXTURE_2D);
	
	glColor4f(0.8f, 0.0f, 1.0f, 0.1f);
	glDepthMask(GL_FALSE);
	glDisable(GL_DEPTH_TEST);
	
	//save old matrix
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	//glTranslatef(x,y,z);
	glBegin(GL_QUADS);
	
	glVertex3f(x, y, z);
	glVertex3f(x+xl, y, z);
	glVertex3f(x+xl, y+yl, z);
	glVertex3f(x, y+yl, z);
	
	glVertex3f(x, y, z);
	glVertex3f(x, y+yl, z);
	glVertex3f(x, y+yl, z+zl);
	glVertex3f(x, y, z+zl);
	
	glVertex3f(x+xl, y, z);
	glVertex3f(x+xl, y+yl, z);
	glVertex3f(x+xl, y+yl, z+zl);
	glVertex3f(x+xl, y, z+zl);
	
	glVertex3f(x, y, z);
	glVertex3f(x, y, z+zl);
	glVertex3f(x+xl, y, z+zl);
	glVertex3f(x+xl, y, z);
	
	glVertex3f(x+xl, y+yl, z);
	glVertex3f(x, y+yl, z);
	glVertex3f(x, y+yl, z+zl);
	glVertex3f(x+xl, y+yl, z+zl);
	
	glVertex3f(x+xl, y, z+zl);
	glVertex3f(x+xl, y+yl, z+zl);
	glVertex3f(x, y+yl, z+zl);
	glVertex3f(x, y, z+zl);
	
	glEnd();
	
	glPopMatrix();
	
	//restore standard render settings
	glEnable(GL_TEXTURE_2D);
	glDepthMask(GL_TRUE);
	glEnable(GL_DEPTH_TEST);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
}