#ifndef SN_FONTTYPER
#define SN_FONTTYPER

#include "sn_TextureCollection.h"
#include "sn_TextureSegmentList.h"
#include <string>
using namespace std;

#define snft_MaxStringSize 1024


class sn_FontTyper
{
public:
	void init( sn_TextureCollection * pTC );
	void load( string fontTextureName );
	
	void type( float x, float y, float z, const char * text, ... );
	void type( float x, float y, float z, float scaleMultiplier, bool center, const char * text, ... ); //ignores internal state
	
	//type2D starts scale at set pixel ratio
	void type2D( float x, float y, const char * text, ... );
	void type2D( float x, float y, float scaleMultiplier, bool center, const char * text, ... ); //ignores internal state
	
	void typeChar( float x, float y, float z, float scaleMultiplier, bool center, int charNumber );
	void typeChar2D( float x, float y, float scaleMultiplier, bool center, int charNumber );
	
	float getLength( const char * text, ... );
	float getLength2D( const char * text, ... );
	
	float getPixelHeight();
	
	void setScale( float newScale );
	void setCentered( bool torf);
	
private:
	sn_TextureCollection * pTextures;
	GLuint fontTextureID;
	sn_TextureSegmentList letters;
	float pixelHeight;
	bool centered;
	float scale;
	
	string removeExtension( const string &s );
};

#endif
