#ifndef SN_GAME
#define SN_GAME

#include "sn_global.h"
#include "g_musicBox.h"
#include "g_Noisemaker.h"
#include "sn_textureCollection.h"
#include "sn_Stage.h"
#include "sn_FontTyper.h"
#include <string>
using namespace std;


#define kMusic_none -1
#define kMusic_title 0
#define kMusic_victory 1
#define kMusic_failure 2
#define kMusic_gentle 3

#define kFX_buzz 0
#define kFX_missileHit 1
#define kFX_missileBlast 2
#define kFX_click 3
#define kFX_playerMissile 4
#define kFX_tactical1 5
#define kFX_tactical2 6
#define kFX_tactical3 7
#define kFX_tactical4 8
#define kFX_shieldSection 9
#define kFX_shieldBarrier 10
#define kFX_timer 11
#define kFX_lose 12

class sn_Game
{
public:
	sn_Game();
	~sn_Game();
	
	void reset();
	void preEvent();
	void processEvent( SDL_Event &event );
	void setResolution (int xRes,int yRes);
	Uint32 updateTicksPassed();
	Uint32 getTicksPassed();
	
	void loadTitleStage();
	void loadNextStage();
	void resetStage();
	void reloadStage();
	
	int screenResX;
	int screenResY;
	float gameResX;
	float gameResY;
	float resMultiplierX;
	float resMultiplierY;
	int useWindow;
	int musicOn;
	int soundOn;
	
	g_MusicBox musicBox;
	g_Noisemaker noisemaker;
	
	//g_RNG rng; //random number generator
	
	//pointer position: *important: these are only updated when processEvent is called!
	Sint32 pointerX, pointerY; 
	Sint32 pointerRelX, pointerRelY; //change in pointer position
	
	int currentStage;
	
	int gameover;
	int chooseOptions;
	int changeScreen;
	int quit;
	int edit;
	int playEditedStage;
	int totalPlayStages;
	
	int musicMuted;
	int sfxMuted;
	int muted;
	
	sn_Stage * pStage;
	sn_TextureCollection textures;
	
	sn_FontTyper typer;
	
private:
	
	vector<string>stageNames;
		
	Uint32 ticksNow;
	Uint32 ticksAtLastUpdate;
	Uint32 ticksSinceLastUpdate;
	int firstRelativeRead;
};

typedef sn_Game* sn_GamePtr;

#endif