//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SN_GAMEPHASE
#define SN_GAMEPHASE

#include "sn_Game.h"
#include "sn_global.h"

class sn_GamePhase
{
public:
	sn_GamePhase( sn_Game * gameToUse );
    virtual ~sn_GamePhase() = 0;
	

	virtual void start() = 0;
	virtual void pause() = 0;
	virtual void unpause() = 0;
	virtual void end() = 0;
    virtual void reset() = 0;
	virtual void processEvent( SDL_Event &event ) = 0;
    virtual void animate() = 0;
	virtual void draw() = 0;
	int isDone();
	
protected:
    int done;
	int paused;
	sn_Game * game;
};

typedef sn_GamePhase* sn_GamePhasePtr;

#endif