#ifndef SN_MOVEMENTARRAY
#define SN_MOVEMENTARRAY

#include "SDL_OpenGL.h"

#include <iostream>
#include <vector>
#include <string>
using namespace std;

#define kNorth 0
#define kEast 1
#define kSouth 2
#define kWest 3
#define kUp 4
#define kDown 5

namespace snmt
{
	enum eMoveType
	{
		free,
		blocked,
		eblocked,  //blocks enemies only
		rampUp,
		rampDown
	};
	
}

struct sn_MovementPoint
{
	snmt::eMoveType direction[6]; //n,e,s,w,up,down
};

class sn_MovementArray
{
public:
	sn_MovementArray();
	sn_MovementArray( int x, int y, int z );
	void resize( int x, int y, int z );

	void setMovement( int x, int y, int z, int dir, snmt::eMoveType mType );
	snmt::eMoveType getMovement( int x, int y, int z, int dir );
	
	int getXSize() const;
	int getYSize() const;
	int getZSize() const;
	
	void setBorder();
	
	void draw();
	
private:
	vector<sn_MovementPoint> moves;
	int xSize;
	int ySize;
	int zSize;
	
	inline int getIndex(int x, int y, int z) { 
		int index = x + y * xSize + z * ySize * xSize;
		if (x >= xSize || y >= ySize || z >= zSize) return -1;
		return index;
	}
};

#endif