#ifndef SN_MOVEMENTDELTAS
#define SN_MOVEMENTDELTAS

#include "sn_MovementArray.h"
#include "sn_global.h"
#include <string>
#include <fstream>
using namespace std;

struct sn_movementDelta
{
	int xOffset, yOffset, zOffset;
	int movementDirection;
	snmt::eMoveType newMoveType;
};

class sn_MovementDeltas
{
public:
	void init( sn_MovementArray * movementArray );
	int load( string filename );
	void applyAt( unsigned int x, unsigned int y, unsigned int z, int facing );
	void applyTempAt( unsigned int x, unsigned int y, unsigned int z, int facing );
	void applyFreeAt( unsigned int x, unsigned int y, unsigned int z, int facing ); //for erasing a set of deltas effects
	void add(sn_movementDelta md);
	void clear();
	
	vector<sn_movementDelta>::const_iterator getDeltasBeginItr();
	vector<sn_movementDelta>::const_iterator getDeltasEndItr();

private:
	vector<sn_movementDelta>deltas;
	sn_MovementArray* pMovementArray;
	snmt::eMoveType stringToMoveType(const string & name);
	int charToDir(const char dirChar);
};

#endif