#ifndef SN_PHASE_OPTIONS
#define SN_PHASE_OPTIONS

#include "sn_global.h"
#include "sn_GamePhase.h"
#include "sn_Button.h"
#include "sn_Prefs.h"

class sn_Phase_Options : public sn_GamePhase
{
public:
	sn_Phase_Options( sn_Game * gameToUse );
	~sn_Phase_Options();
	
	virtual void start();
	virtual void pause();
	virtual void unpause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:    
	Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	void drawTitle();
	void drawPointer();
	
	int showingTitle;
	int erasingTitle;
	int confirming;
	Uint32 timeTitleStarted;
	Uint32 timeTitleEnded;
	
	const static int totalWindowButtons = 4;
	const static int maxResButtons =  100;
	sn_Button button_res[maxResButtons];
	sb_point availableRes[maxResButtons];
	int totalResButtons;
	int firstFullButtonShowing;
	
	sn_Button button_music;
	sn_Button button_sound;
	sn_Button button_done;
	sn_Button button_up;
	sn_Button button_down;
	
	sn_Button label_window;
	sn_Button label_full;
	
	sn_Button label_ok;
	sn_Button button_yes;
	sn_Button button_no;
	sn_Button label_timer;
	
	sn_Button button_UL;
	sn_Button button_LL;

	Uint32 timeConfirmStarted;
	Uint32 confirmTotalSeconds;
	Sint16 confirmSecondsLeft;
	
	int oldResX;
	int oldResY;
	int oldWindow;
	
	int selectedButton;
	int oldSelectedButton;
	
	sn_Prefs pref;
};

#endif