//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SN_PHASE_TITLE
#define SN_PHASE_TITLE

#include "sn_GamePhase.h"
#include "sn_Button.h"  
#include "g_angle.h"
#include "sn_Recording.h"

#include "sn_TextureSegmentList.h"
#include "sn_AnimationSeqList.h"
#include "sn_Sprite.h"
#include <vector>

using namespace std;

class sn_Phase_Title : public sn_GamePhase
{
public:
	sn_Phase_Title( sn_Game * gameToUse );
	~sn_Phase_Title();
	
	virtual void start();
	virtual void pause();
	virtual void unpause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:    
	Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	void drawTitle();
	void drawPointer();
	
	int showingTitle;
	int erasingTitle;
	Uint32 timeTitleStarted;
	Uint32 timeTitleEnded;
	
	sn_Button startButton;
	sn_Button optionsButton;
	sn_Button quitButton;
	sn_Button editButton;
	
	GLuint titleTextureID;
	sn_TextureSegmentList titleSegList;
	
	sn_AnimationSeqList udgAnim;
	sn_Sprite udg;
	
	float arcEndX;
	g_angle zCameraAngle;
	float zCameraAngleTarget;
	int cameraRotatingCW, cameraRotatingCCW;
	float zCameraRotationSpeed;
	float zCameraAngleHalfwayToTarget;
	
	float cameraZoom, cameraZoomTarget;
	int cameraZoomingIn, cameraZoomingOut;
	float cameraZoomSpeed;
	
	vector <bool> keyhold;
};

#endif