#ifndef SN_PLAYER
#define SN_PLAYER

#define sn_confident 0
#define sn_sad 1
#define sn_scared 2
#define sn_happy 3


#include "sn_StageElement.h"
#include "sn_TextureCollection.h"
#include "sn_AnimationSeqList.h"
#include "sn_Sprite.h"

class sn_Player : public sn_StageElement
{
public:
	void init(sn_TextureCollection * pTextureCollection);
	virtual void draw( float rotation );
	virtual void drawAlpha( float rotation );
	
	void moveTo( float absX, float absY, float absZ );
	void setTarget(float tx, float ty, float tz);
	void setTargetRelative(float dx, float dy, float dz);
	void setBounceTargetRelative(float dx, float dy, float dz);
	void spit();
	bool isActive();
	
	
	void changeExpression( int expression );
	
	void animate( unsigned int ticksPassed );
	bool falling;
	float size;

private:
	float oldX, oldY, oldZ;
	float targetX, targetY, targetZ;
	float deltaX, deltaY, deltaZ;
	bool moving;
	bool bouncingBack;
	bool spitting;
	int currentExpression;
	
	sn_TextureCollection * pTextures;
	sn_AnimationSeqList eyeAnimList;
	sn_AnimationSeqList ballAnimList;
	sn_Sprite eyeSprite;
	sn_Sprite eyeAwaySprite;
	sn_Sprite ballSprite;
	sn_Sprite ballAwaySprite;
};

#endif