#include "sn_Prefs.h"
#include "sn_Game.h"
#include <string>
using namespace std;

sn_Prefs::sn_Prefs()
{
	#if defined(__APPLE__)
	string thePath = GAMETITLE + ".app/Contents/Resources/prefs.txt";
	#else
	string thePath = "data/prefs.txt";
	#endif
	
	strcpy(path, thePath.c_str());
	loaded = false;
}

void sn_Prefs::setPath(char * newPath)
{
	strcpy(path, newPath);
}

void sn_Prefs::changeWidth(int newWidth)
{
	if (!loaded) load();
	width = newWidth;
	write();
}

void sn_Prefs::changeHeight(int newHeight)
{
	if (!loaded) load();
	height = newHeight;
	write();
}
void sn_Prefs::changeWindow(int newUseWindow)
{
	if (!loaded) load();
	useWindow = newUseWindow;
	write();
}

void sn_Prefs::changeMusic(int newUseMusic)
{
	if (!loaded) load();
	useMusic = newUseMusic;
	write();
}
void sn_Prefs::changeSound(int newUseSound)
{
	load();
	useSound = newUseSound;
	write();
}
void sn_Prefs::changeToDefault()
{
	ofstream prefFileOut;
	prefFileOut.open(path, ios::out);
	prefFileOut << 800 << '\n';
	prefFileOut << 600 << '\n';
	prefFileOut << true << '\n';
	prefFileOut << true << '\n';
	prefFileOut << true << '\n';
	prefFileOut.close();
	
}
void sn_Prefs::load()
{
	ifstream testFile,prefFile;
	testFile.open(path, ios::in);
	if (!testFile)
	{
		testFile.close();
		changeToDefault();
	}
	else
	{
		testFile.close();
	}
	prefFile.open(path, ios::in);
	prefFile >> width;
	prefFile >> height;
	prefFile >> useWindow;
	prefFile >> useMusic;
	prefFile >> useSound;
	prefFile.close();
	loaded = true;
}

void sn_Prefs::write()
{
	ofstream prefFileOut;
	prefFileOut.open(path, ios::out);
	prefFileOut << width << '\n';
	prefFileOut << height << '\n';
	prefFileOut << useWindow << '\n';
	prefFileOut << useMusic << '\n';
	prefFileOut << useSound << '\n';
	prefFileOut.close();
}

int sn_Prefs::getWidth()
{
	if (!loaded) load();
	return width;
}
int sn_Prefs::getHeight()
{
	if (!loaded) load();
	return height;
}
int sn_Prefs::getUseWindow()
{
	if (!loaded) load();
	return useWindow;
}
int sn_Prefs::getUseMusic()
{
	if (!loaded) load();
	return useMusic;
}
int sn_Prefs::getUseSound()
{
	if (!loaded) load();
	return useSound;
}