#ifndef SN_PROJECTILE
#define SN_PROJECTILE

#include "sn_StageElement.h"
#include "sn_TextureCollection.h"
#include "sn_AnimationSeqList.h"
#include "sn_Sprite.h"

using namespace std;

class sn_Projectile : public sn_StageElement
{
public:
	void init(sn_TextureCollection * pTextureCollection);
	virtual void draw( float rotation );
	virtual void drawAlpha( float rotation );
	
	void launch(float xStart, float yStart, float zStart, int compassDir);
	void registerHit();
	
	bool isActive();
	
	void animate( unsigned int ticksPassed );

	float size;
	
private:
	float oldX, oldY, oldZ;
	float targetX, targetY, targetZ;
	float deltaX, deltaY, deltaZ;
	bool moving;
	float speed;
	
	sn_TextureCollection * pTextures;
	sn_AnimationSeqList ballAnimList;
	sn_Sprite ballSprite;
	sn_Sprite ballAwaySprite;
};

#endif