#ifndef SN_PUSHABLEBLOCKCOLLECTION
#define SN_PUSHABLEBLOCKCOLLECTION

#include "sn_PushableBlock.h"
#include <string>
using namespace std;

class sn_PushableBlockCollection
{
public:
	void init( sn_3DmodelCollection * p3DModelCollection, sn_MovementArray * pMA, vector<sn_StageElement*> * pSE );
	void clear();
	int load(const string &filename);
	int save(const string &filename);
	sn_PushableBlock* addNew( float x, float y, float z, int blockType);
	void updateMovementDeltas();
	bool eraseArea( float x, float y, float z);
	
	void animate( unsigned int ticksPassed );
	void dropTest(); //test for new situation in which blocks should fall
	
	vector<sn_PushableBlock*>::iterator findCollidingBlock( sn_Collider &c);
	vector<sn_PushableBlock*>::iterator findCollidingBlock( vector<sn_PushableBlock*>::iterator &pBlock);
	
	vector<sn_PushableBlock*>::iterator getBeginItr();
	vector<sn_PushableBlock*>::iterator getEndItr();
	
private:
	vector<sn_PushableBlock*> blocks;
	sn_3DmodelCollection * pModels;
	sn_MovementArray * pMovementArray;
	vector<sn_StageElement*> * hStageElements;
	
	vector<string>modelFilenames;
	vector<string>movementMapFilenames;
};

#endif
