#ifndef SN_RECORDING
#define SN_RECORDING

#include "sn_global.h"
#include <string>
#include <vector>
#include <fstream>
using namespace std;

struct sn_recordingStep
{
	int primary;
	int action;
	unsigned int timeStamp;
};

class sn_Recording
{
public:
	sn_Recording();
	
	void record( unsigned int ticksPassed );
	void recordAction( int action );
	void recordSecondaryAction( int action );
	int playAndGetAction( unsigned int ticksPassed ); //returning -1 means no new action and playtimeHead was advanced
	int playAndGetSecondaryAction( unsigned int ticksPassed );
	
	bool isAtEnd();
	
	int load( string filename );
	int save( string filename ) const;
	void reset();

private:
	
	vector <sn_recordingStep> steps;
	vector<sn_recordingStep>::const_iterator itr;
	unsigned int playheadTime;
	unsigned int secondaryPlayheadTime;
};

#endif