#ifndef SN_SCREEN
#define SN_SCREEN

#include "SDL.h"
#include "SDL_OpenGL.h"
//strangely, the following include is needed even though SDL_OpenGL.h is supposed to take care of it.
#if defined(__APPLE__)
#include <OpenGL/OpenGL.h>
#endif
#include "sn_global.h"

class sn_Screen
{
public:
	int init(Uint16 gameWidth, Uint16 gameHeight, Uint16 screenWidth, Uint16 screenHeight, 
			 Uint16 colorDepth, int useWindow, const char * windowName);
	int resize(Uint16 screenWidth, Uint16 screenHeight, Uint16 colorDepth, int useWindow);
	void revert();
	
	Uint16 getGameW();
	Uint16 getGameH();
	Uint16 getW();
	Uint16 getH();
	int usingWindow();
	Uint16 getColorDepth();

private:
		
	void Quit( int returnCode );
	char name[50];
	Uint16 gameW;
	Uint16 gameH;
	Uint16 resW;
	Uint16 resH;
	int window;
	Uint16 depth;
	
	Uint16 resWOld;
	Uint16 resHOld;
	int windowOld;
	Uint16 depthOld;
	
	
};
#endif