#ifndef SN_SPRITE
#define SN_SPRITE

#include "SDL_OpenGL.h"
#include "sn_global.h"
#include "sn_AnimationSeqList.h"
#include <iostream>
#include <string>
using namespace std;

class sn_Sprite
{
public:
	sn_Sprite();
	void init (sn_AnimationSeqList * animationSequenceList);
	void startSequence (string animationSequenceName);
	void animate( unsigned int ticksPassed );
	void draw();
	void draw(float scale, bool horizFlip, bool vertFlip);
	bool atEnd() const;
	void setLoop(bool trueOrFalse);
	void pause();
	void unpause();
private:
	sn_AnimationSeqList * animSeqList;
	string currSequenceName;
	int currFrame;
	int currTotalFrames;
	unsigned int currDelayTime;
	unsigned int currDuration;
	bool loop;
	bool reachedEnd;
	bool paused;
};

#endif