#ifndef SN_TEXTURESEGMENTLIST
#define SN_TEXTURESEGMENTLIST

#include "SDL_OpenGL.h"
#include "sn_global.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
using namespace std;

struct sn_textureSegment
{
	float texX1, texY1, texX2, texY2; //between 0.0 and 1.0, coordinates of upper left and lower right of texture
	float relX1, relY1, relX2, relY2; //where upper left and lower right corners are relative to center of place to display segment
};

class sn_TextureSegmentList
{
public:
	sn_TextureSegmentList();
	void init(GLuint textureID);
	int load(string filename);
	
	int draw( int segmentIndex) const;
	int draw( int segmentIndex, float scale, bool horizFlip, bool vertFlip) const;
	int getSize() const;
	
	float getWidth( int segmentIndex ) const;
	float getPixelHeight() const;
	
private:
	vector<sn_textureSegment> segments;
	GLuint texID;
	float pixelHeight;
};

#endif