//Copyright (c) 2004 Aaron Sullivan. All rights reserved.

#ifndef SN_GLOBAL
#define SN_GLOBAL

#include "g_RNG.h"
#include "SDL.h"

#include <math.h>
#include <iostream>
//#include "sb_Circle.h"
#include <string>



//Player Controls
#define sn_UL 0
#define sn_UR 1
#define sn_LR 2
#define sn_LL 3
#define sn_Shoot 4
#define sn_FUL 5
#define sn_FUR 6
#define sn_FLR 7
#define sn_FLL 8
#define sn_E_confident 10
#define sn_E_sad 11
#define sn_E_scared 12
#define sn_E_happy 13
#define sn_Up 20
#define sn_Down 21
#define sn_CamZoomIn 22
#define sn_CamZoomOut 23
#define sn_CamRotateCW 24
#define sn_CamRotateCC 25
#define sn_NextModel 26
#define sn_LastModel 27
#define sn_SaveStage 28
#define sn_LoadStage 29
#define sn_EraseBlock 30
#define sn_AddPushableBlock 31
#define sn_AddPlayerStart 32
#define sn_PlayEditedStage 33
#define sn_AddOtherSnowball 34

#define sn_totalPlayerControls 34

using namespace std;
const string GAMETITLE("Snowball");

// useful macros
#ifndef MIN
#define MIN(A,B)	((A) < (B) ? (A) : (B))
#endif
#ifndef MAX
#define MAX(A,B)	((A) > (B) ? (A) : (B))
#endif
#ifndef CLAMP
#define CLAMP(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))
#endif

struct sb_point
{
	float x, y;
};

struct sb_vector
{
	float dx, dy;
};

struct sb_color
{
	float r, g, b, a;
};

#define k_piDivBy180 0.01745329f
#define k_180DivByPi 57.29582f

static inline float angleInRadians( float angle )
{
	return angle * k_piDivBy180;
}

//find cosine of an angle in degrees
static inline float sb_cosD( float angleInDegrees )
{
	if (angleInDegrees == 90.0f || angleInDegrees == 270.0f)
	{
		return 0.0f;
	}
	else if (angleInDegrees == 0.0f)
	{
		return 1.0f;
	}
	else if (angleInDegrees == 180.0f)
	{
		return -1.0f;
	}
	else
	{
		angleInDegrees = angleInRadians(angleInDegrees);
		return cos(angleInDegrees);
	}
}

//find sine of an angle in degrees
static inline float sb_sinD( float angleInDegrees )
{
	if (angleInDegrees == 0.0f || angleInDegrees == 180.0f)
	{
		return 0.0f;
	}
	else if (angleInDegrees == 90.0f)
	{
		return 1.0f;
	}
	else if (angleInDegrees == 270.0f)
	{
		return -1.0f;
	}
	else
	{
		angleInDegrees = angleInRadians(angleInDegrees);
		return sin(angleInDegrees);
	}
}

//find angle in degrees that is arctangent of an number 
static inline float sb_atanD( float x )
{
	float angleInRadians;

	angleInRadians = atan( x );
	return angleInRadians * k_180DivByPi; //convert to degrees
}

static inline float g_roundToWhole( float x )
{
	return float((int)(x + 0.5f));
}

static inline string g_removeExtension( const string &s )
{
	string newString;
	string::size_type i = 0;
	while (i != s.size() && s[i] != '.') 
		++i;
	
	newString = s.substr(0,i);
	
	return newString;
}

//easier to read replacements
typedef SDL_Surface* SDL_SurfacePtr; 
typedef SDL_PixelFormat* SDL_PixelFormatPtr;

/*SDL.h gives us these AND checks to be sure they are correct for the platform we are using
typedef unsigned char	Uint8;
typedef signed char	    Sint8;
typedef unsigned short	Uint16;
typedef signed short	Sint16;
typedef unsigned int	Uint32;
typedef signed int	    Sint32;

struct {
    SDL_FALSE = 0,
    SDL_TRUE = 1
}SDL_bool;

#define SDL_TABLESIZE(table)    (sizeof(table)/sizeof(table[0]))

From SDL_video.h we get:

#define SDL_ALPHA_OPAQUE 255
#define SDL_ALPHA_TRANSPARENT 0

typedef struct {
    Sint16 x, y;
    Uint16 w, h;
} SDL_Rect;

typedef struct {
    Uint8 r;
    Uint8 g;
    Uint8 b;
    Uint8 unused;
} SDL_Color;

*/
#endif
